diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv4-global-routing.cc ns-3.46/src/internet/model/ipv4-global-routing.cc
--- ns-3.45/src/internet/model/ipv4-global-routing.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv4-global-routing.cc	2025-10-01 18:46:32.000000000 -0700
@@ -71,6 +71,15 @@
     NS_LOG_FUNCTION(this << dest << nextHop << interface);
     auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateHostRouteTo(dest, nextHop, interface);
+    for (auto routePointer : m_hostRoutes)
+    {
+        if (*routePointer == *route)
+        {
+            NS_LOG_LOGIC("Route already exists");
+            delete route;
+            return;
+        }
+    }
     m_hostRoutes.push_back(route);
 }
 
@@ -80,6 +89,15 @@
     NS_LOG_FUNCTION(this << dest << interface);
     auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateHostRouteTo(dest, interface);
+    for (auto routePointer : m_hostRoutes)
+    {
+        if (*routePointer == *route)
+        {
+            NS_LOG_LOGIC("Route already exists");
+            delete route;
+            return;
+        }
+    }
     m_hostRoutes.push_back(route);
 }
 
@@ -92,6 +110,15 @@
     NS_LOG_FUNCTION(this << network << networkMask << nextHop << interface);
     auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, nextHop, interface);
+    for (auto routePointer : m_networkRoutes)
+    {
+        if (*routePointer == *route)
+        {
+            NS_LOG_LOGIC("Route already exists");
+            delete route;
+            return;
+        }
+    }
     m_networkRoutes.push_back(route);
 }
 
@@ -101,6 +128,15 @@
     NS_LOG_FUNCTION(this << network << networkMask << interface);
     auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, interface);
+    for (auto routePointer : m_networkRoutes)
+    {
+        if (*routePointer == *route)
+        {
+            NS_LOG_LOGIC("Route already exists");
+            delete route;
+            return;
+        }
+    }
     m_networkRoutes.push_back(route);
 }
 
@@ -113,6 +149,15 @@
     NS_LOG_FUNCTION(this << network << networkMask << nextHop << interface);
     auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, nextHop, interface);
+    for (auto routePointer : m_ASexternalRoutes)
+    {
+        if (*routePointer == *route)
+        {
+            NS_LOG_LOGIC("Route already exists");
+            delete route;
+            return;
+        }
+    }
     m_ASexternalRoutes.push_back(route);
 }
 
@@ -147,9 +192,13 @@
     if (allRoutes.empty()) // if no host route is found
     {
         NS_LOG_LOGIC("Number of m_networkRoutes" << m_networkRoutes.size());
+        // store the length of the longest mask.
+        uint16_t longest_mask = 0;
         for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
         {
             Ipv4Mask mask = (*j)->GetDestNetworkMask();
+            uint16_t masklen = mask.GetPrefixLength();
+
             Ipv4Address entry = (*j)->GetDestNetwork();
             if (mask.IsMatch(dest, entry))
             {
@@ -161,8 +210,23 @@
                         continue;
                     }
                 }
-                allRoutes.push_back(*j);
                 NS_LOG_LOGIC(allRoutes.size() << "Found global network route" << *j);
+                if (masklen < longest_mask) // Not interested if got shorter mask
+                {
+                    NS_LOG_LOGIC("Previous match longer, skipping");
+                    continue;
+                }
+                else if (masklen == longest_mask)
+                {
+                    NS_LOG_LOGIC("Equal mask length, adding this to the list");
+                    allRoutes.push_back(*j);
+                }
+                else
+                {
+                    NS_LOG_LOGIC("Longer mask length found, clearing the list and adding");
+                    allRoutes.clear();
+                    allRoutes.push_back(*j);
+                }
             }
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv4.h ns-3.46/src/internet/model/ipv4.h
--- ns-3.45/src/internet/model/ipv4.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv4.h	2025-10-01 18:46:32.000000000 -0700
@@ -445,24 +445,6 @@
     virtual bool GetIpForward() const = 0;
 
     /**
-     * @brief Get the Weak Es Model status
-     *
-     * RFC1122 term for whether host accepts datagram with a dest. address on another interface
-     * @returns true for Weak Es Model activated
-     */
-    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
-    virtual bool GetWeakEsModel() const = 0;
-
-    /**
-     * @brief Set or unset the Weak Es Model
-     *
-     * RFC1122 term for whether host accepts datagram with a dest. address on another interface
-     * @param model true for Weak Es Model
-     */
-    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
-    virtual void SetWeakEsModel(bool model) = 0;
-
-    /**
      * @brief Set or unset the Strong End System Model
      *
      * RFC1122 term for whether host rejects datagram with a dest. address on another interface
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv4-l3-protocol.cc ns-3.46/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.45/src/internet/model/ipv4-l3-protocol.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv4-l3-protocol.cc	2025-10-01 18:46:32.000000000 -0700
@@ -631,13 +631,6 @@
         }
     }
 
-    for (auto i = m_sockets.begin(); i != m_sockets.end(); ++i)
-    {
-        NS_LOG_LOGIC("Forwarding to raw socket");
-        Ptr<Ipv4RawSocketImpl> socket = *i;
-        socket->ForwardUp(packet, ipHeader, ipv4Interface);
-    }
-
     if (m_enableDpd && ipHeader.GetDestination().IsMulticast() && UpdateDuplicate(packet, ipHeader))
     {
         NS_LOG_LOGIC("Dropping received packet -- duplicate.");
@@ -1095,6 +1088,14 @@
 
     m_localDeliverTrace(ipHeader, p, iif);
 
+    Ptr<Ipv4Interface> ipv4Interface = GetInterface(iif);
+
+    for (auto& socket : m_sockets)
+    {
+        NS_LOG_INFO("Delivering to raw socket " << socket);
+        socket->ForwardUp(p, ipHeader, ipv4Interface);
+    }
+
     Ptr<IpL4Protocol> protocol = GetProtocol(ipHeader.GetProtocol(), iif);
     if (protocol)
     {
@@ -1401,19 +1402,6 @@
 }
 
 void
-Ipv4L3Protocol::SetWeakEsModel(bool model)
-{
-    NS_LOG_FUNCTION(this << model);
-    m_strongEndSystemModel = !model;
-}
-
-bool
-Ipv4L3Protocol::GetWeakEsModel() const
-{
-    return !m_strongEndSystemModel;
-}
-
-void
 Ipv4L3Protocol::SetStrongEndSystemModel(bool model)
 {
     NS_LOG_FUNCTION(this << model);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv4-l3-protocol.h ns-3.46/src/internet/model/ipv4-l3-protocol.h
--- ns-3.45/src/internet/model/ipv4-l3-protocol.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv4-l3-protocol.h	2025-10-01 18:46:32.000000000 -0700
@@ -289,13 +289,6 @@
     void SetIpForward(bool forward) override;
     bool GetIpForward() const override;
 
-    /** @copydoc Ipv4::SetWeakEsModel */
-    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
-    void SetWeakEsModel(bool model) override;
-    /** @copydoc Ipv4::GetWeakEsModel */
-    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
-    bool GetWeakEsModel() const override;
-
     void SetStrongEndSystemModel(bool model) override;
     bool GetStrongEndSystemModel() const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv4-packet-info-tag.cc ns-3.46/src/internet/model/ipv4-packet-info-tag.cc
--- ns-3.45/src/internet/model/ipv4-packet-info-tag.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv4-packet-info-tag.cc	2025-10-01 18:46:32.000000000 -0700
@@ -11,7 +11,7 @@
 #include "ns3/ipv4-address.h"
 #include "ns3/log.h"
 
-#include <stdint.h>
+#include <cstdint>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv6-autoconfigured-prefix.cc ns-3.46/src/internet/model/ipv6-autoconfigured-prefix.cc
--- ns-3.45/src/internet/model/ipv6-autoconfigured-prefix.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv6-autoconfigured-prefix.cc	2025-10-01 18:46:32.000000000 -0700
@@ -18,8 +18,18 @@
 
 NS_LOG_COMPONENT_DEFINE("Ipv6AutoconfiguredPrefix");
 
+NS_OBJECT_ENSURE_REGISTERED(Ipv6AutoconfiguredPrefix);
+
 uint32_t Ipv6AutoconfiguredPrefix::m_prefixId = 0;
 
+TypeId
+Ipv6AutoconfiguredPrefix::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::Ipv6AutoconfiguredPrefix").SetParent<Object>().SetGroupName("Internet");
+    return tid;
+}
+
 Ipv6AutoconfiguredPrefix::Ipv6AutoconfiguredPrefix(Ptr<Node> node,
                                                    uint32_t interface,
                                                    Ipv6Address prefix,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv6-autoconfigured-prefix.h ns-3.46/src/internet/model/ipv6-autoconfigured-prefix.h
--- ns-3.45/src/internet/model/ipv6-autoconfigured-prefix.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv6-autoconfigured-prefix.h	2025-10-01 18:46:32.000000000 -0700
@@ -30,6 +30,12 @@
 {
   public:
     /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    /**
      * @brief Constructor.
      * @param node node
      * @param interface interface index
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv6-l3-protocol.cc ns-3.46/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.45/src/internet/model/ipv6-l3-protocol.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv6-l3-protocol.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1048,13 +1048,6 @@
         }
     }
 
-    /* forward up to IPv6 raw sockets */
-    for (auto it = m_sockets.begin(); it != m_sockets.end(); ++it)
-    {
-        Ptr<Ipv6RawSocketImpl> socket = *it;
-        socket->ForwardUp(packet, hdr, device);
-    }
-
     Ptr<Ipv6ExtensionDemux> ipv6ExtensionDemux = m_node->GetObject<Ipv6ExtensionDemux>();
     Ptr<Ipv6Extension> ipv6Extension = nullptr;
     uint8_t nextHeader = hdr.GetNextHeader();
@@ -1442,6 +1435,7 @@
     bool isDropped = false;
     bool stopProcessing = false;
     DropReason dropReason;
+    Ptr<NetDevice> device = GetNetDevice(iif);
 
     // check for a malformed hop-by-hop extension
     // this is a common case when forging IPv6 raw packets
@@ -1534,6 +1528,12 @@
 
                 m_localDeliverTrace(newIpHeader, p, iif);
 
+                for (auto& socket : m_sockets)
+                {
+                    NS_LOG_INFO("Delivering to raw socket " << socket);
+                    socket->ForwardUp(p, newIpHeader, device);
+                }
+
                 IpL4Protocol::RxStatus status =
                     protocol->Receive(p, newIpHeader, GetInterface(iif));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/ipv6-packet-info-tag.cc ns-3.46/src/internet/model/ipv6-packet-info-tag.cc
--- ns-3.45/src/internet/model/ipv6-packet-info-tag.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/ipv6-packet-info-tag.cc	2025-10-01 18:46:32.000000000 -0700
@@ -10,7 +10,7 @@
 
 #include "ns3/ipv6-address.h"
 
-#include <stdint.h>
+#include <cstdint>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/rtt-estimator.cc ns-3.46/src/internet/model/rtt-estimator.cc
--- ns-3.45/src/internet/model/rtt-estimator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/rtt-estimator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -63,12 +63,13 @@
     : m_nSamples(0)
 {
     NS_LOG_FUNCTION(this);
+}
 
-    // We need attributes initialized here, not later, so use the
-    // ConstructSelf() technique documented in the manual
-    ObjectBase::ConstructSelf(AttributeConstructionList());
+void
+RttEstimator::NotifyConstructionCompleted()
+{
+    NS_LOG_FUNCTION(this);
     m_estimatedRtt = m_initialEstimatedRtt;
-    m_estimatedVariation = Time(0);
     NS_LOG_DEBUG("Initialize m_estimatedRtt to " << m_estimatedRtt.GetSeconds() << " sec.");
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/rtt-estimator.h ns-3.46/src/internet/model/rtt-estimator.h
--- ns-3.45/src/internet/model/rtt-estimator.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/rtt-estimator.h	2025-10-01 18:46:32.000000000 -0700
@@ -89,6 +89,8 @@
     Time m_initialEstimatedRtt; //!< Initial RTT estimation
 
   protected:
+    void NotifyConstructionCompleted() override;
+
     Time m_estimatedRtt;       //!< Current estimate
     Time m_estimatedVariation; //!< Current estimate variation
     uint32_t m_nSamples;       //!< Number of samples
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/tcp-header.cc ns-3.46/src/internet/model/tcp-header.cc
--- ns-3.45/src/internet/model/tcp-header.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/tcp-header.cc	2025-10-01 18:46:32.000000000 -0700
@@ -14,8 +14,8 @@
 #include "ns3/buffer.h"
 #include "ns3/log.h"
 
+#include <cstdint>
 #include <iostream>
-#include <stdint.h>
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/tcp-socket-base.cc ns-3.46/src/internet/model/tcp-socket-base.cc
--- ns-3.45/src/internet/model/tcp-socket-base.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/tcp-socket-base.cc	2025-10-01 18:46:32.000000000 -0700
@@ -52,7 +52,7 @@
 #include "ns3/uinteger.h"
 
 #include <algorithm>
-#include <math.h>
+#include <cmath>
 
 namespace
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.45/src/internet/test/global-route-manager-impl-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -6,19 +6,53 @@
  *
  * Authors:  Tom Henderson (tomhend@u.washington.edu)
  *
+ * Modified By: Shashwat Patni (shashwatpatni25@gmail.com)
+ *
  * Kunihiro Ishigura, Toshiaki Takada (GNU Zebra) are attributed authors
  * of the quagga 0.99.7/src/ospfd/ospf_spf.c code which was ported here
  */
 
 #include "ns3/candidate-queue.h"
+#include "ns3/config.h"
 #include "ns3/global-route-manager-impl.h"
+#include "ns3/internet-module.h"
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-global-routing-helper.h"
+#include "ns3/ipv4-global-routing.h"
+#include "ns3/network-module.h"
+#include "ns3/node-container.h"
+#include "ns3/rng-seed-manager.h"
+#include "ns3/simple-net-device-helper.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
 
 #include <cstdlib> // for rand()
-
 using namespace ns3;
 
+NS_LOG_COMPONENT_DEFINE("GlobalRouteManagerImplTestSuite");
+
+//
+// This test suite is designed to check the Working of the GlobalRouteManagerImpl
+// For that reason, the tests in this suite manually build LSAs for each topology
+// we manually call DebugSPFCalculate() to fill routing tables of the node we are interested in.
+//
+//  TestCase 1: LinkRoutesTestCase
+//  This test case tests that:
+//  - GLobalRouteManagerLSDB stores the LSAs with key as the correct link state ID
+//  - GlobalRouteManagerImpl checks for stubnodes and computes default routes for them
+//  - HostRoutes are computed correctly for point-to-point links
+//
+//  TestCase 2: LanRoutesTestCase
+//  This test case tests that:
+//  - Network LSAs are handled by the GlobalRouteManagerImpl
+//  - GlobalRouteManagerImpl computes the routes correctly for a LAN topology
+//
+//  TestCase 3: RandomEcmpRoutesTestCase
+//  This test case tests that:
+//  - GlobalRouteManagerImpl computes ECMP routes correctly.
+//  - Those random routes are in fact used by the GlobalRouting protocol
+//
+
 /**
  * @ingroup internet
  * @ingroup tests
@@ -30,39 +64,60 @@
  *
  * @brief Global Route Manager Test
  */
-class GlobalRouteManagerImplTestCase : public TestCase
+class LinkRoutesTestCase : public TestCase
 {
   public:
-    GlobalRouteManagerImplTestCase();
+    LinkRoutesTestCase();
+    void DoSetup() override;
     void DoRun() override;
+
+  private:
+    /**
+     *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
+     * GlobalRouteManagerLSDB.Each node exports a router LSA.
+     */
+    void BuildLsa();
+
+    /**
+     *  @brief Checks the Routing Table Entries for the expected output.
+     * @param globalroutingprotocol The routing protocol for the node whose routing table is to be
+     * checked.
+     * @param dests The expected destinations.
+     * @param gws The expected gateways.
+     */
+    void CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                     std::vector<Ipv4Address>& dests,
+                     std::vector<Ipv4Address>& gws);
+
+    NodeContainer nodes;                   //!< NodeContainer to hold the nodes in the topology
+    std::vector<GlobalRoutingLSA*> m_lsas; //!< The LSAs for the topology
 };
 
-GlobalRouteManagerImplTestCase::GlobalRouteManagerImplTestCase()
-    : TestCase("GlobalRouteManagerImplTestCase")
+LinkRoutesTestCase::LinkRoutesTestCase()
+    : TestCase("LinkRoutesTestCase")
 {
 }
 
 void
-GlobalRouteManagerImplTestCase::DoRun()
+LinkRoutesTestCase::CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                                std::vector<Ipv4Address>& dests,
+                                std::vector<Ipv4Address>& gws)
 {
-    CandidateQueue candidate;
-
-    for (int i = 0; i < 100; ++i)
+    // check each individual Routing Table Entry for its destination and gateway
+    for (uint32_t i = 0; i < globalroutingprotocol->GetNRoutes(); i++)
     {
-        auto v = new SPFVertex;
-        v->SetDistanceFromRoot(std::rand() % 100);
-        candidate.Push(v);
-    }
-
-    for (int i = 0; i < 100; ++i)
-    {
-        SPFVertex* v = candidate.Pop();
-        delete v;
-        v = nullptr;
+        Ipv4RoutingTableEntry* route = globalroutingprotocol->GetRoute(i);
+        NS_LOG_DEBUG("dest " << route->GetDest() << " gw " << route->GetGateway());
+        NS_TEST_ASSERT_MSG_EQ(route->GetDest(), dests[i], "Error-- wrong destination");
+        NS_TEST_ASSERT_MSG_EQ(route->GetGateway(), gws[i], "Error-- wrong gateway");
     }
+}
 
-    // Build fake link state database; four routers (0-3), 3 point-to-point
-    // links
+void
+LinkRoutesTestCase::DoSetup()
+{
+    // Simple p2p links. n0,n1 and n3 are stub nodes
+    //
     //
     //   n0
     //      \ link 0
@@ -72,18 +127,56 @@
     //      / link 1
     //    n1
     //
-    //  link0:  10.1.1.1/30, 10.1.1.2/30
-    //  link1:  10.1.2.1/30, 10.1.2.2/30
-    //  link2:  10.1.3.1/30, 10.1.3.2/30
+    //  link0:  n0->10.1.1.1/30, n2-> 10.1.1.2/30
+    //  link1:  n1-> 10.1.2.1/30, n2->10.1.2.2/30
+    //  link2:  n2->10.1.3.1/30, n3-> 10.1.3.2/30
+    //
     //
+    //
+
+    nodes.Create(4);
+
+    Ipv4GlobalRoutingHelper globalhelper;
+    InternetStackHelper stack;
+    stack.SetRoutingHelper(globalhelper);
+    stack.Install(nodes);
+
+    SimpleNetDeviceHelper devHelper;
+    devHelper.SetNetDevicePointToPointMode(true);
+    Ptr<SimpleChannel> channel1 = CreateObject<SimpleChannel>();
+    NetDeviceContainer d02 = devHelper.Install(nodes.Get(0), channel1);
+    d02.Add(devHelper.Install(nodes.Get(2), channel1));
+    Ptr<SimpleChannel> channel2 = CreateObject<SimpleChannel>();
+    NetDeviceContainer d12 = devHelper.Install(nodes.Get(1), channel2);
+    d12.Add(devHelper.Install(nodes.Get(2), channel2));
+    Ptr<SimpleChannel> channel3 = CreateObject<SimpleChannel>();
+    NetDeviceContainer d23 = devHelper.Install(nodes.Get(2), channel3);
+    d23.Add(devHelper.Install(nodes.Get(3), channel3));
+
+    // Assign IP addresses to the devices
+    Ipv4AddressHelper address;
+    address.SetBase("10.1.1.0", "255.255.255.252");
+    Ipv4InterfaceContainer i02 = address.Assign(d02);
+    address.SetBase("10.1.2.0", "255.255.255.252");
+    Ipv4InterfaceContainer i12 = address.Assign(d12);
+    address.SetBase("10.1.3.0", "255.255.255.252");
+    Ipv4InterfaceContainer i23 = address.Assign(d23);
+}
+
+void
+LinkRoutesTestCase::BuildLsa()
+{
+    // Manually build the link state database; four routers (0-3), 3 point-to-point
+    // links
+
     // Router 0
     auto lr0 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.2",  // router ID 0.0.0.2
-                                           "10.1.1.1", // local ID
+                                           "0.0.0.2",  // link id -> router ID 0.0.0.2
+                                           "10.1.1.1", // link data -> Local IP address of router 0
                                            1);         // metric
 
     auto lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.1",
+                                           "10.1.1.2", // link id ->adjacent neighbor's IP address
                                            "255.255.255.252",
                                            1);
 
@@ -91,8 +184,10 @@
     lsa0->SetLSType(GlobalRoutingLSA::RouterLSA);
     lsa0->SetLinkStateId("0.0.0.0");
     lsa0->SetAdvertisingRouter("0.0.0.0");
+    lsa0->SetNode(nodes.Get(0));
     lsa0->AddLinkRecord(lr0);
     lsa0->AddLinkRecord(lr1);
+    m_lsas.push_back(lsa0);
 
     // Router 1
     auto lr2 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
@@ -101,7 +196,7 @@
                                            1);
 
     auto lr3 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.2.1",
+                                           "10.1.2.2",
                                            "255.255.255.252",
                                            1);
 
@@ -111,6 +206,8 @@
     lsa1->SetAdvertisingRouter("0.0.0.1");
     lsa1->AddLinkRecord(lr2);
     lsa1->AddLinkRecord(lr3);
+    lsa1->SetNode(nodes.Get(1));
+    m_lsas.push_back(lsa1);
 
     // Router 2
     auto lr4 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
@@ -119,7 +216,7 @@
                                            1);
 
     auto lr5 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.2",
+                                           "10.1.1.1",
                                            "255.255.255.252",
                                            1);
 
@@ -135,7 +232,7 @@
 
     auto lr8 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
                                            "0.0.0.3",
-                                           "10.1.3.2",
+                                           "10.1.3.1",
                                            1);
 
     auto lr9 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
@@ -153,15 +250,17 @@
     lsa2->AddLinkRecord(lr7);
     lsa2->AddLinkRecord(lr8);
     lsa2->AddLinkRecord(lr9);
+    lsa2->SetNode(nodes.Get(2));
+    m_lsas.push_back(lsa2);
 
     // Router 3
     auto lr10 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
                                             "0.0.0.2",
-                                            "10.1.2.1",
+                                            "10.1.3.2",
                                             1);
 
     auto lr11 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                            "10.1.2.1",
+                                            "10.1.3.1",
                                             "255.255.255.252",
                                             1);
 
